/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.antrax.commons.VoipAntiSpamListNumbersStatus;
import com.flamesgroup.storage.convert.DateConverter;
import com.flamesgroup.storage.convert.VoipAntiSpamListNumbersStatusConverter;
import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.VoipAntiSpamBlackListNumbersRecord;

import java.util.Arrays;
import java.util.Date;
import java.util.List;

import org.jooq.Field;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VoipAntiSpamBlackListNumbers extends TableImpl<VoipAntiSpamBlackListNumbersRecord> {

	private static final long serialVersionUID = 1651011826;

	/**
	 * The reference instance of <code>public.voip_anti_spam_black_list_numbers</code>
	 */
	public static final VoipAntiSpamBlackListNumbers VOIP_ANTI_SPAM_BLACK_LIST_NUMBERS = new VoipAntiSpamBlackListNumbers();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<VoipAntiSpamBlackListNumbersRecord> getRecordType() {
		return VoipAntiSpamBlackListNumbersRecord.class;
	}

	/**
	 * The column <code>public.voip_anti_spam_black_list_numbers.number</code>.
	 */
	public final TableField<VoipAntiSpamBlackListNumbersRecord, String> NUMBER = createField("number", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

	/**
	 * The column <code>public.voip_anti_spam_black_list_numbers.status</code>.
	 */
	public final TableField<VoipAntiSpamBlackListNumbersRecord, VoipAntiSpamListNumbersStatus> STATUS = createField("status", org.jooq.impl.SQLDataType.CLOB.nullable(false).defaulted(true), this, "", new VoipAntiSpamListNumbersStatusConverter());

	/**
	 * The column <code>public.voip_anti_spam_black_list_numbers.status_description</code>.
	 */
	public final TableField<VoipAntiSpamBlackListNumbersRecord, String> STATUS_DESCRIPTION = createField("status_description", org.jooq.impl.SQLDataType.CLOB.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.voip_anti_spam_black_list_numbers.add_time</code>.
	 */
	public final TableField<VoipAntiSpamBlackListNumbersRecord, Date> ADD_TIME = createField("add_time", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false).defaulted(true), this, "", new DateConverter());

	/**
	 * The column <code>public.voip_anti_spam_black_list_numbers.routing_request_count</code>.
	 */
	public final TableField<VoipAntiSpamBlackListNumbersRecord, Integer> ROUTING_REQUEST_COUNT = createField("routing_request_count", org.jooq.impl.SQLDataType.INTEGER.defaulted(true), this, "");

	/**
	 * Create a <code>public.voip_anti_spam_black_list_numbers</code> table reference
	 */
	public VoipAntiSpamBlackListNumbers() {
		this("voip_anti_spam_black_list_numbers", null);
	}

	/**
	 * Create an aliased <code>public.voip_anti_spam_black_list_numbers</code> table reference
	 */
	public VoipAntiSpamBlackListNumbers(String alias) {
		this(alias, VOIP_ANTI_SPAM_BLACK_LIST_NUMBERS);
	}

	private VoipAntiSpamBlackListNumbers(String alias, Table<VoipAntiSpamBlackListNumbersRecord> aliased) {
		this(alias, aliased, null);
	}

	private VoipAntiSpamBlackListNumbers(String alias, Table<VoipAntiSpamBlackListNumbersRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<VoipAntiSpamBlackListNumbersRecord> getPrimaryKey() {
		return Keys.VOIP_ANTI_SPAM_SPAM_GRAY_LIST_NUMBERS_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<VoipAntiSpamBlackListNumbersRecord>> getKeys() {
		return Arrays.<UniqueKey<VoipAntiSpamBlackListNumbersRecord>>asList(Keys.VOIP_ANTI_SPAM_SPAM_GRAY_LIST_NUMBERS_PKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public VoipAntiSpamBlackListNumbers as(String alias) {
		return new VoipAntiSpamBlackListNumbers(alias, this);
	}

	/**
	 * Rename this table
	 */
	public VoipAntiSpamBlackListNumbers rename(String name) {
		return new VoipAntiSpamBlackListNumbers(name, null);
	}
}
